using System;
using System.Runtime.InteropServices;


namespace NewtonDynamics
{
	internal partial class Newton
	{
		[DllImport("Newton.dll")]
		internal static extern IntPtr NewtonConstraintCreateUserJoint(IntPtr pNewtonWorld,
			int pMaxDOF,
			NewtonUserBilateral pCallback,
			IntPtr pChildBody,
			IntPtr pParentBody);

		[DllImport("Newton.dll")]
		internal static extern void NewtonUserJointAddLinearRow(IntPtr pJoint,
			[MarshalAs(UnmanagedType.LPArray, SizeConst = 3)]float[] pPivot0,
			[MarshalAs(UnmanagedType.LPArray, SizeConst = 3)]float[] pPivot1,
			[MarshalAs(UnmanagedType.LPArray, SizeConst = 3)]float[] pdir);

		[DllImport("Newton.dll")]
		internal static extern void NewtonUserJointAddAngularRow(IntPtr pJoint,
			float pRelativeAngle,
			[MarshalAs(UnmanagedType.LPArray, SizeConst = 3)]float[] pDir);

		[DllImport("Newton.dll")]
		internal static extern void NewtonUserJointAddGeneralRow(IntPtr pJoint,
			[MarshalAs(UnmanagedType.LPArray, SizeConst = 6)]float[] pJacobian0,
			[MarshalAs(UnmanagedType.LPArray, SizeConst = 6)]float[] pJacobian1);

		[DllImport("Newton.dll")]
		internal static extern void NewtonUserJointSetRowMinimumFriction(IntPtr pJoint,
			float pFriction);
	
		[DllImport("Newton.dll")]
		internal static extern void NewtonUserJointSetRowMaximumFriction(IntPtr pJoint,
			float pFriction);
	
		[DllImport("Newton.dll")]
		internal static extern void NewtonUserJointSetRowAcceleration(IntPtr pJoint,
			float pAcceleration);
	
		[DllImport("Newton.dll")]
		internal static extern void NewtonUserJointSetRowSpringDamperAcceleration(IntPtr pJoint,
			float pSpringK,
			float pSpringD);
	
		[DllImport("Newton.dll")]
		internal static extern void NewtonUserJointSetRowStiffness(IntPtr pJoint,
			float pStiffness);
	
		[DllImport("Newton.dll")]
		internal static extern float NewtonUserJointGetRowForce(IntPtr pJoint,
			int pRow);
	}
}
